unit CopyDataToMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TWMCopyData = record
    Msg: Cardinal;
    SourceWnd: HWnd;
    lpCopyData: PCopyDataStruct;
    Result: Integer;
  end;

  TForm1 = class(TForm)
    SG: TStringGrid;
    procedure FormShow(Sender: TObject);
  private
    procedure WMCopyData(var Msg: TWMCopyData);
      message wm_CopyData;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMCopyData(var Msg: TWMCopyData);
{ lParam of WM_COPYDATA message points to...
  PCopyDataStruct = ^TCopyDataStruct;
  TCopyDataStruct = packed record
    dwData: DWORD;    //4 bytes of custom data
    cbData: DWORD;    //size of other data
    lpData: Pointer;  //pointer to other data which
                      //cannot contain pointers
  end; }
const
  StartNewGrid = -1;
  Y: Integer = -1;
var
  X: Integer;
  Data: String;
begin
  with Msg, lpCopyData^ do
  begin
    Result := 1;
    if dwData = StartNewGrid then
    begin
      SG.ColCount := TPoint(lpData^).X + 1;
      SG.RowCount := TPoint(lpData^).Y;
      SG.FixedCols := 1;
      SG.FixedRows := 1;
      SG.ColWidths[0] := 0;
      Y := -1;
    end
    else
    begin
      X := dwData;
      if X = 0 then
        Inc(Y);
      SetString(Data, PChar(lpData), cbData);
      SG.Cells[X + 1, Y] := Data;
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  try
    //Parent EXE window handle is passed on command-line
    SendMessage(StrToInt(ParamStr(1)), wm_App + 10, Handle, 0)
  except
    raise Exception.Create('Pass a window handle on the command-line')
  end;
end;

end.
