unit CopyingU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, 
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure FileCopyWithStreams(const InFile, OutFile: String);
var
  InStream, OutStream: TFileStream;
begin
  InStream := TFileStream.Create(InFile, fmOpenRead + fmShareDenyWrite);
  try
    OutStream := TFileStream.Create(OutFile, fmCreate);
    try
      OutStream.CopyFrom(InStream, 0); { 0 means whole stream }
      FileSetDate(OutStream.Handle, FileGetDate(InStream.Handle));
    finally
      OutStream.Free;
    end;
  finally
    InStream.Free;
  end;
end;

procedure FileCopyWithFileVars(const InFileName, OutFileName: String);
const
  BufSize = 8 * 4096; { 32kb }
type
  PBuffer = ^TBuffer;
  TBuffer = array[1..BufSize] of Byte;
var
  Size: Cardinal;
  Buffer: PBuffer;
  InFile, OutFile: File;
begin
  if InFileName = OutFileName then
    raise EInOutError.Create('File cannot be copied onto itself')
  else
  begin
    Buffer := nil;
    Assign(InFile, InFileName);
    Reset(InFile, 1);
    try
      Assign(OutFile, OutFileName);
      Rewrite(OutFile, 1);
      try
        New(Buffer);
        repeat
          BlockRead(InFile, Buffer^, BufSize, Size);
          BlockWrite(OutFile, Buffer^, Size)
        until Size < BufSize;
        FileSetDate(TFileRec(OutFile).Handle,
          FileGetDate(TFileRec(InFile).Handle))
      finally
        if Buffer <> nil then
          Dispose(Buffer);
        CloseFile(OutFile)
      end
    finally
      CloseFile(InFile)
    end
  end
end;

end.
 